\chapter{\acrshort{mpc} in Condensed Form \label{app:MPCCondensed}}

The \gls{mpc} control task \eqref{eq:MPC_Sparse_Form} is reformulated to condensed form by defining
\begin{alignat}{1}
	\bm{X} \meq \begin{bmatrix}
		\bm{x}_1\transpose & \bm{x}_2\transpose & \dots & \bm{x}_N\transpose 
	\end{bmatrix}\transpose, \\
	\bm{Y} \meq \begin{bmatrix}
		\bm{y}_1\transpose & \bm{y}_2\transpose & \dots & \bm{y}_N\transpose
	\end{bmatrix}\transpose, \\
	\bm{U} \meq \begin{bmatrix}
		\bm{u}_0\transpose & \bm{u}_1\transpose & \dots & \bm{u}_{N-1}\transpose 
	\end{bmatrix}\transpose, \\
	\Delta\bm{U} \meq \begin{bmatrix}
		\Delta\bm{u}_0\transpose & \Delta\bm{u}_1\transpose & \dots & \Delta\bm{u}_{N-1}\transpose 
	\end{bmatrix}\transpose, \\
	\bm{Y}^{*} \meq \begin{bmatrix}
		\bm{r}_1\transpose & \bm{r}_2\transpose & \dots & \bm{r}_N\transpose 
	\end{bmatrix}\transpose.
\end{alignat}
Using these vectors, the cost function in \eqref{eq:MPC_Sparse_Form_J} can be expressed as
\begin{alignat}{1}
	J \meq (\bm{Y}^{*} - \bm{Y})\transpose\xbar{\bm{Q}}(\bm{Y}^{*} - \bm{Y}) + \Delta\bm{U}\transpose\xbar{\bm{R}}\Delta\bm{U}, \label{eq:MPC_Condensed_J_Vector}
\end{alignat}
where
\begin{alignat}{2}
	\xbar{\bm{Q}} \meq \begin{bmatrix}
		\bm{Q} & \bm{0} & \cdots \\
		\bm{0} & \bm{Q} \\
		\vdots & & \ddots \\
		& & & \bm{Q}
	\end{bmatrix}, \qquad
	\xbar{\bm{R}} \meq \begin{bmatrix}
		\bm{R} & \bm{0} & \cdots \\
		\bm{0} & \bm{R} \\
		\vdots & & \ddots \\
		& & & \bm{R}
	\end{bmatrix}.
\end{alignat}
Equations describing the model \eqref{eq:MPC_Sparse_Form_Model1} and \eqref{eq:MPC_Sparse_Form_Model2} are rewritten as
\begin{alignat}{1}
	\bm{X} \meq \xbar{\bm{A}}\bm{x}_0 + \xbar{\bm{B}}\bm{U}, \label{eq:MPC_Condensed_X}\\
	\bm{Y} \meq \xbar{\bm{C}}\bm{X}, \label{eq:MPC_Condensed_Y}
\end{alignat}
where
\begin{alignat}{2}
	\xbar{\bm{A}} \meq \begin{bmatrix}
		\bm{A} \\ \bm{A}^2 \\  \bm{A}^3 \\ \vdots \\ \bm{A}^N
	\end{bmatrix}, \qquad
	\xbar{\bm{B}} \meqna \begin{bmatrix}
		\bm{B} & \bm{0} & \bm{0} & \cdots \\
		\bm{A}\bm{B} & \bm{B} & \bm{0}  & \cdots \\
		\bm{A}^2\bm{B} & \bm{A}\bm{B} & \bm{B}  & \cdots \\
		\vdots & \vdots & \vdots & \ddots \\
		\bm{A}^{N-1}\bm{B} & \bm{A}^{N-2}\bm{B} & \bm{A}^{N-3}\bm{B} & \cdots & \bm{B}
	\end{bmatrix}, \\
	\xbar{\bm{C}} \meq \begin{bmatrix}
		\bm{C} & \bm{0} & \cdots \\
		\bm{0} & \bm{C} &  \\
		\vdots & & \ddots \\
		       &        &        &  \bm{C}
	\end{bmatrix}.
\end{alignat}
Vector $\Delta\bm{U}$ can be expressed as
\begin{alignat}{1}
	\Delta\bm{U} \meq \xbar{\bm{S}}\bm{U} - \xbar{\bm{E}}\bm{u}_{-1},\label{eq:MPC_Condensed_DeltaU}
\end{alignat}
where
\begin{alignat}{2}
	 \xbar{\bm{S}} \meq \begin{bmatrix}
		 \bm{I} &  \bm{0} & \bm{0} & \cdots \\
		-\bm{I} &  \bm{I} & \bm{0} &  \\
		 \bm{0} & -\bm{I} & \bm{I} &  \\
		 \vdots &         &        & \ddots \\
		        &         &  &  & \bm{I}
	 \end{bmatrix}, \qquad \xbar{\bm{E}} \meq \begin{bmatrix}
		 \;\bm{I}\; \\ \bm{0} \\ \bm{0} \\ \vdots \\ \bm{0}
	 \end{bmatrix}.
\end{alignat}
The dimensions of identity matrix $\bm{I}$ are $n_u \times n_u$, where $n_u = 2$ is the number of inputs.

Using \eqref{eq:MPC_Condensed_X}, \eqref{eq:MPC_Condensed_Y}, and \eqref{eq:MPC_Condensed_DeltaU}, the cost function \eqref{eq:MPC_Condensed_J_Vector} is rewritten as
\begin{alignat}{1}
 	J \meq (\bm{Y}^{*} - \xbar{\bm{C}}\xbar{\bm{A}}\bm{x}_0 - \xbar{\bm{C}}\xbar{\bm{B}}\bm{U})\transpose\xbar{\bm{Q}}
 		(\bm{Y}^{*} - \xbar{\bm{C}} \xbar{\bm{A}}\bm{x}_0 - \xbar{\bm{C}}\xbar{\bm{B}}\bm{U}) \cr 
 		\;&+\; 
 		(\xbar{\bm{S}}\bm{U} - \xbar{\bm{E}}\bm{u}_{-1})\transpose\xbar{\bm{R}}(\xbar{\bm{S}}\bm{U} - \xbar{\bm{E}}\bm{u}_{-1}).
\end{alignat}
Expanding, rearranging, and using the fact that $\xbar{\bm{Q}}$ and $\xbar{\bm{R}}$ are symmetric
\begin{alignat}{1}
	J \meq \frac{1}{2}\bm{U}\transpose\bm{H}\bm{U} + \xbar{\bm{F}}\transpose\bm{U} + c,
\end{alignat}
where
\begin{alignat}{1}
	\bm{H} \meq 2\braRound{\xbar{\bm{B}}\transpose\xbar{\bm{C}}\transpose\xbar{\bm{Q}}\xbar{\bm{C}}\xbar{\bm{B}} + \xbar{\bm{S}}\transpose\xbar{\bm{R}}\xbar{\bm{S}}}, \\
	\xbar{\bm{F}}\transpose \meq 2\braRound{\bm{x}_0\transpose\xbar{\bm{A}}\transpose\xbar{\bm{C}}\transpose\xbar{\bm{Q}}\xbar{\bm{C}}\xbar{\bm{B}} - \bm{u}_{-1}\transpose\xbar{\bm{E}}\transpose\xbar{\bm{R}}\xbar{\bm{S}} - {\bm{Y}^{*}}\transpose\xbar{\bm{Q}}\xbar{\bm{C}}\xbar{\bm{B}}}, \\
	c \meq \braRound{{\bm{Y}^*}\transpose - \xbar{\bm{C}}\xbar{\bm{A}}\bm{x}_0}\transpose \xbar{\bm{Q}} \braRound{{\bm{Y}^*}\transpose - \xbar{\bm{C}}\xbar{\bm{A}}\bm{x}_0} + \bm{u}_{-1}\transpose \xbar{\bm{E}}\transpose \xbar{\bm{R}}\xbar{\bm{E}}\bm{u}_{-1}.
\end{alignat}
Further
\begin{alignat}{1}
	J \meq \frac{1}{2}\bm{U}\transpose\bm{H}\bm{U} + \begin{bmatrix}
		\bm{x}_0\transpose & \bm{u}_{-1}\transpose & {\bm{Y}^*}\transpose
	\end{bmatrix}\bm{F}\transpose\bm{U} + c,
\end{alignat}
where
\begin{alignat}{1}
	\bm{F}\transpose \meq \begin{bmatrix}
		2\xbar{\bm{A}}\transpose\xbar{\bm{C}}\transpose\xbar{\bm{Q}}\xbar{\bm{C}}\xbar{\bm{B}} \\
		-2\xbar{\bm{E}}\transpose\xbar{\bm{R}}\xbar{\bm{S}} \\
		-2\xbar{\bm{Q}}\xbar{\bm{C}}\xbar{\bm{B}}
	\end{bmatrix}.
\end{alignat}
As $c$ is a constant that does not depend on the optimization variable $\bm{U}$, it does not influence the solution of the optimization problem.
Thus,
\begin{alignat}{1}
	\tilde{J} \meq \frac{1}{2}\bm{U}\transpose\bm{H}\bm{U} + \begin{bmatrix}
		\bm{x}_0\transpose & \bm{u}_{-1}\transpose & {\bm{Y}^*}\transpose
	\end{bmatrix}\bm{F}\transpose\bm{U}
\end{alignat}
has the same minimizer as $J$.

The inequality constraints \eqref{eq:MPC_Sparse_Form_Constr1} and \eqref{eq:MPC_Sparse_Form_Constr2} are rewritten as
\begin{alignat}{1}
	\xbar{\bm{P}}_x \bm{X} \mleq \xbar{\bm{p}}_x, \label{eq:MPC_inequalityX_v1} \\
	\xbar{\bm{P}}_u \bm{U} \mleq \xbar{\bm{p}}_u, \label{eq:MPC_inequalityU_v1}
\end{alignat}
where
\begin{alignat}{2}
	\xbar{\bm{P}}_x \meq \begin{bmatrix}
		\bm{P}_x & \bm{0}   & \cdots \\
		\bm{0}   & \bm{P}_x &  \\
		\vdots   &   & \ddots \\
		         &          &        &  \bm{P}_x
	\end{bmatrix} , \qquad
	\xbar{\bm{p}}_x \meq \begin{bmatrix}
		 \bm{p}_x \\ \bm{p}_x \\ \vdots \\ \bm{p}_x
	 \end{bmatrix} ,\\
	\xbar{\bm{P}}_u \meq \begin{bmatrix}
		\bm{P}_u & \bm{0}   & \cdots \\
		\bm{0}   & \bm{P}_u &  \\
		\vdots   &   & \ddots \\
		         &          &        &  \bm{P}_u
	\end{bmatrix} , \qquad
	\xbar{\bm{p}}_u \meq \begin{bmatrix}
		 \bm{p}_u \\ \bm{p}_u \\ \vdots \\ \bm{p}_u
	 \end{bmatrix} .
\end{alignat}
Using \eqref{eq:MPC_Condensed_X} the constraint \eqref{eq:MPC_inequalityX_v1} is rewritten as
\begin{alignat}{1}
	\xbar{\bm{P}}_x \xbar{\bm{B}} \bm{U} \mleq \xbar{\bm{p}}_x - \xbar{\bm{P}}_x \xbar{\bm{A}}\bm{x}_0. \label{eq:MPC_inequalityX_v2}
\end{alignat}
Combining \eqref{eq:MPC_inequalityU_v1} and \eqref{eq:MPC_inequalityX_v2} gives
\begin{alignat}{1}
	\bm{G} \bm{U} \mleq \bm{W} + \bm{S}\bm{x}_0,
\end{alignat} 
where
\begin{alignat}{2}
	\bm{G} \meq \begin{bmatrix}
		\xbar{\bm{P}}_x \xbar{\bm{B}} \\
		\xbar{\bm{P}}_u
	\end{bmatrix}, \qquad 
	\bm{W} \meq \begin{bmatrix}
		\xbar{\bm{p}}_x \\
		\xbar{\bm{p}}_u
	\end{bmatrix},  \qquad 
	\bm{S} \meq \begin{bmatrix}
		- \xbar{\bm{P}}_x \xbar{\bm{A}} \\
		\bm{0}
	\end{bmatrix}.
\end{alignat}

Therefore, \gls{mpc} control task can be written in condensed form as
\begin{subequations}
\label{eq:MPC_Condensed_Form}
\begin{alignat}{3}
	\min\limits_{\bm{z}}\quad &  & 
	& \hspace{-2.2em}\frac{1}{2} \bm{z}\transpose\bm{H}\bm{z} + \begin{bmatrix}
		\bm{x}_0\transpose & \bm{u}_{-1}\transpose & \bm{r}_1\transpose & \bm{r}_2\transpose & \dots & \bm{r}_N\transpose
	\end{bmatrix}\bm{F}\transpose\bm{z}\\
	\textrm{s.t.}\quad &  &
	\bm{G} \bm{z} \mleq \bm{W} + \bm{S}\bm{x}_0, \\ & &
	\bm{z} \meq \begin{bmatrix}
		{\bm{u}_0\transpose} & {\bm{u}_1\transpose} & \dots & {\bm{u}_{N-1\transpose}}		
	\end{bmatrix}\transpose,\\ & &
	\bm{x}_0 \meq \bm{x}(t),  \\ & &
	\bm{u}_{-1} \meq \bm{u}(t - T_{\textrm{s}}),\\ & &
	\bm{r}_{k} \meq \bm{r}(t + kT_{\textrm{s}}), \quad k \;=\; 1,\, 2,\, \dots, \, N.
\end{alignat}.
\end{subequations}

